/*

This is an ebarassingly poor example, ESP8266-only, for the CLab_MCP4631 driver library.
You could strip out the wifi stuff - or at a minimum, will need to change it to fit your network.
This is also an example of how to get a static IP address, which I happened to need as part of
the original project.
This uses the ESP default I2C pins, which are GPIO4=SDA, GPIO5=SCL, and I added 2.7k pullups.
A motivated student could allow passing in pins to the constuctor instead.
This also assumes we're using unit 0, with a base address of 0x28h.  There are three
more address bits on the chip that could be wired high so the address could be up to 0x2fh.

I left in some code where I just did it "on the metal" without the class...but commented out.
Written by Doug Coulter, 12/31/17 if it works, if not, I don't know who wrote it.  GPLv2


*/


#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
#include <Wire.h> 
//#include <FS.h>
#include <CLab_MCP4631.h>

// board manager url's, handy to add in IDE preferences:
//http://arduino.esp8266.com/stable/package_esp8266com_index.json,
//https://adafruit.github.io/arduino-board-index/package_adafruit_index.json

///////// this stuff is custom to your network and access point - change as needed
const char* ssid = "dougswap";
const char* password = "fusordoug";
IPAddress ip(192,168,1,205); // Node static IP!
IPAddress gateway(192,168,1,1);
IPAddress subnet(255,255,255,0);
////////// end of network-specific stuff

int errors;

WiFiUDP tport;
WiFiUDP dport;
char packetBuffer[255];
#define DNSPORT 53831 // landns UDP port
#define DATAPORT 42042 // port for PC communication

IPAddress myip; // my ip as assigned by dhcp or static
IPAddress bcip; // broadcast addr for this network
unsigned char mac[6]; // my mac, I hope
char tellem_string[40]; // What we'll broadcast
int packetSize; //incoming size info
unsigned long tellems; // how many times we've done this (uptime, kind of)
unsigned long loop_millis;
#define MINUTE_MS 60000
unsigned long minute_z; // milliseconds since last tell

CLab_MCP4631 dpot;


////////////////////////////////////
void init_ram ()
{
  tellems = errors = 0;
  minute_z = millis();
  
}
////////////////////////////////////
///////////////////////////////////
void build_tellem_string ()
{
  int i;
  String mystring;

//@@@ class String can't 0 pad hex...
// but sprintf and strncpy are lots more lines of code (less rom though)
  mystring = myip.toString();
  mystring += " ESP_";
  for (i=3;i<6;i++) 
  {
    if (16 > mac[i]) mystring += "0"; // yes, it is that dumb    
    mystring += String(mac[i],HEX);
   }
   mystring += "_FB1"; // add your suffix here
  mystring.toUpperCase(); // because damn, that's what it is on the net for some retarded opsys
  mystring.toCharArray(tellem_string, 39);
}
////////////////////////////////////
void tellem()
{
  tport.beginPacket(bcip,DNSPORT);
  tport.write(tellem_string);
  tport.endPacket(); 
  tellems++; // for grins, count them
//  Serial.println(tellem_string);
}
////////////////////////////////////
void ditch_incoming()
{ // ignore other broadcasts, maybe stop possible memory leak.
  // You MUST do this with other things on the LAN broadcasting
  // or library loses its mind - 
  packetSize = tport.parsePacket();
  if (packetSize) {
    int len = tport.read(packetBuffer, 254);
  }
}
////////////////////////////////////
void set_wiper(char which, char pos)
{
 Wire.beginTransmission(0x28);
 Wire.write(which);
 Wire.write(pos);
 Wire.endTransmission(0x28);
}
////////////////////////////////////
void setup() {
  Serial.begin(115200);
  Serial.println("Booting");
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
 //   Serial.println("Connection Failed! Rebooting..."); // no printing as we're using the port for the power supply
    delay(5000);
    ESP.restart();
  }
  WiFi.config(ip, gateway, subnet);

  WiFi.macAddress(mac); // get my MAC addr, as it's part of hostname
  myip = WiFi.localIP(); // class and union of dword and 4 bytes
  bcip = myip; // copy net address but
  bcip[3] = 255; // make it broadcast address
  build_tellem_string();
  init_ram();
  tport.begin(DNSPORT); // for tellem
  delay(300);
  ArduinoOTA.begin();
  Serial.println("Ready");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
//  Wire.begin();
  dpot.begin(0x28);
  
}

char i;
void loop() {

  loop_millis = millis(); // just do this once
  if (loop_millis - minute_z >= MINUTE_MS)
  {
    minute_z = loop_millis; // update for next time
    tellem(); // 1/minute stuff
    yield();
  } //
  
  ditch_incoming(); // must do this or library leaks memory and dies
  yield();
  ArduinoOTA.handle();
  i++;
  i &= 0x7f;
//  set_wiper(0,i);
  dpot.writeWiper(0,i);
  delay (1);
  // test serial port output
//  Serial.print(errors++);
//  Serial.println (" A bunch of other bits to see which pin the port output is on...");
//  delay (1000);
}
